;**********************************************************
;
;   Transfert routine from QUILLgame.tap to QUILLgame.dsk
;      
;**********************************************************

;----------------------------------------------------------
;              
;Be sure the file loaded starts at the adress $0440. That means
; there is not a BASIC presentation for example, before the
;           QUILL itself. If not you'll have to manage 
;                to only load  the QUILLed part.
;---------------------------------------------------------- 

;
;Save temporarily page 4 on page A4
;
	sei
	lda #$04
	ldx #$00
	ldy #$a4
	stx $35
	stx $37
	sta $36
	sty $38
	ldy #$00
loop0
	lda ($35),y  ;$35-36 => 0400
	sta ($37),y  ;$37-38 => a400
	iny
	bne loop0
;
; QUIT
;
	lda $43e
	ldy $43f
	sta $f0
	sty $f1
	lda #$78
	ldy #$eb
	sta $23c
	sty $23d
	lda #$b2
	ldy #$f8
	sta $248
	sty $249
;
; clear screen and diplay message on screen 
;
	jsr $ccce		;	CLS
	ldx #$00
loop_mes_01	
	lda mess_01,x
	sta $bC4a,x
	inx
	cpx #$22
	bne loop_mes_01
	
	ldx #$00
loop_mes_02	
	lda mess_02,x
	sta $bc9a,x
	inx
	cpx #$0d
	bne loop_mes_02	
	
	ldy #$07
	ldx #$0A
cur_bas	
	jsr $f77c ; diplay carracter in A (here #$0A means cursor down)
	dey
	bne cur_bas
	
;
; prevent autostart of CLOADed QuilledGame.tap
;

	ldx #$00
loop_st
	lda dta_stop,x
	sta $221,x
	inx
	cpx #$0a
	bne loop_st
	lda #$21
	sta $245
	lda #$02
	sta $246		; $244 JMP $0221 INTEAD OF JMP $EE22

	cli
	rts

mess_01 ; messages to be displayed on screen
.asc "Type in CLOAD'GAME NAME':CALL#A000"
mess_02
.asc "Then <RETURN>"		
	
dta_stop ; data for stop routine
.byt $48			;pha
.byt $a9,$00		;lda #$00
.byt $8d,$ad,$02	;sta $2ad	force to 0 the autostart byte at each interruption
.byt $68			;pla
.byt $4c,$22,$ee	;jmp $ee22	
	
	
dta04	; table of adresses of bytes #$04 to be changed to #$x4
.byt $16,$05,$79,$0f,$54,$0b,$97,$0c,$c0,$0c
.byt $31,$13,$ca,$0c,$d0,$0c,$ef,$0c,$0c,$14
.byt $15,$14,$b2,$14,$b5,$14,$be,$14,$c7,$14
.byt $d4,$14,$06,$15,$33,$15,$38,$15,$40,$15
.byt $4b,$15,$53,$15,$6e,$15,$6a,$14,$42,$04
.byt $12,$0f,$3a,$0f,$45,$0f

;
; table of modified bytes to change CSAVE/CLOAD in SAVE/LOAD
;

dta_save1 ; $0AA9 - $0ABF
.byt $a9,$30,$8d,$52,$c0,$a9,$b2,$8d,$53,$C0,$a9,$55,$8d,$54,$c0,$a9
.byt $b3,$8d,$55,$c0,$20,$07,$14

dta_save2 ; $124F - $1271
.byt $a9,$84,$8d,$14,$03,$a0,$00,$b1,$f3,$c9,$0d,$f0,$08,$99,$29,$c0
.byt $c8,$c0,$09,$d0,$f2,$a9,$20,$99,$29,$c0,$c8,$c0,$0c,$d0,$f8,$60 
.byt $ea,$ea,$ea

dta_save3 ; $140A - $140C
.byt $ea,$ea,$ea

dta_save4 ;1531 - $1543
.byt $a9,$c0,$8d,$4d,$c0,$a9,$40,$8d,$51,$c0,$20,$0b,$de,$a9,$86,$8d
.byt $14,$03,$60

dta_load ; $1412 - $1429
.byt $ad,$09,$c0,$8d,$18,$c0,$a9,$00,$8d,$4d,$c0,$8d,$4e,$c0,$20,$e5
.byt $e0,$a9,$86,$8d,$14,$03,$60,$ea


start
;
; Switch to RAM Overlay and load Track 20 sector 1
;

	sei
	lda #$84
	sta $314  ; Switch to ram overlay
;	lda #$14
;	ldy #$01
;	jsr $da5d ; load track #14 sector 01 into BUFF01

;
; modify INIST	and DNAME in BUFF01. Prepare name of file for SAVE
;
	ldx #$00
loop1
	lda $0293,x ; adress of the name of CLOADed file
	sta $c029,x ; adress of the name of the file to save. Prepare the saving
;	sta $c10b,x ; DNAME adress in BUFF01
;	sta $c11e,x ; INIST adress in BUFF01
	beq skip1	; 00 mark the end of the name
	inx
	cpx #$09    ; Max length of name
	bne loop1
skip1
	lda #$20
loop2	
	sta $c029,x
;	sta $c10b,x
loop3
;	sta $c11e,x
	inx
	cpx #$09
	bne loop2
;	cpx #$3b
;	bne loop3
;
; prepare DATA to save game on disc
; Determination of x for the transfert of the code from $0440- $0509 to $x440_$x509
;
	ldx #$05
	lda #$0a
	sta $c052 ; File Start address in $C052/$C053
	stx $c053 ; here $050A
; determine hh of new adress of  implantation of page 4 code. It is also hh of next start adress and hh-1 of end of file 
	lda $2aC ; hh adress end of tap file 
	pha
	and #$0F
	cmp #$04
	bcc inf_x4
	pla
	clc
	adc #$10
	and #$F0
	clc
	adc #$04
	sta $c057 ; hh adress new start point
	sta $38
	adc #$01
	sta $c055 ; hh adress end of file
	jmp ll_adr
inf_x4
	pla
	and #$f0
	clc
	adc #$04
	sta $c057 ; hh adress new start point
	sta $38
	adc #$01
	sta $c055 ; hh adress new end of file
ll_adr	
	lda #$09 ; ll adress new end of file
	sta $c054
	lda #$40 ; ll adress new start point
	sta $c056
	lda #$41
	sta $c051 ; type de fichier (here machine code auto)
	lda #$c0
	sta $c04d
;
; modify all the JSR $04yz ni JSR $x4yz idem for JMP $04yz and lda $04
; adresses to be modified seemed to be the same for all the QUILLed games
;

	
	ldy #$00
	ldx #$00
loop4
	lda dta04,y
	sta byte_to_change+1		;$39 ==> ll adress  $04 bytes 
	lda dta04+1,y
	sta byte_to_change+2		;$3A ==> hh adress  $04 bytes 	
	lda $c057
byte_to_change
	sta $1233
	iny
	iny
	inx
	cpx #$1c
	bne loop4
		
;
; Modify existing code to transform CSAVE/CLOAD in SAVE/LOAD
;

	ldx #$00
loop5
	lda dta_save1,x
	sta $0aa9,x
	inx
	cpx #$17
	bne loop5 
	ldx #$00
loop6
	lda dta_save2,x
	sta $124f,x
	inx
	cpx #$23
	bne loop6
	ldx #$00
loop7
	lda dta_save3,x
	sta $140a,x
	inx
	cpx #$03
	bne loop7
    ldx #$00	
loop8
	lda dta_save4,x
	sta $1531,x
	inx
	cpx #$13
	bne loop8
	ldx #$00	
loop9
	lda dta_load,x
	sta $1412,x
	inx
	cpx #$18
	bne loop9 
	
;
; Transfer the code between $0440 and $0509 to  $x440 - $x509
;
	lda #$40
	sta $35
	sta $37  ; $37-38 ==> $x440	destination adress of transfered code
	lda #$04
	sta $36  ; $35-36 ==> $0440 start adress of transfered code
	ldy #$00
loop10	
	lda($35),y
	sta($37),y
	iny
	cpy #$ca ; number of bytes to be transfered
	bne loop10

;
; delete checksum effect
;	
	lda #$60 ; RTS
	sta $13f0 ;  6cfcff ie JMP(FFFC) replaced by 60fcff ie RTS

;
; replace SEDORIC's page 4
;
	lda #$a4
	ldx #$00
	ldy #$04
	stx $35   ; $35-36 => a400
	stx $37   ; $37-38 => 0400
	sta $36
	sty $38
	ldy #$00
loop11
	lda ($35),y
	sta ($37),y
	iny
	bne loop11

;
;SAVE the QUILLed game onto disc and boot
;

	jsr $de0b	; SAVE the game file onto disc 
	lda #$00
	sta $0314	; to connect microdisc EPROM
reset
	jmp $eb7e	; COLD RESET (boot)
	
	

	
	
	
	
	
	
	
	
	
	
	
	
	
	